// Tetris Version 1.02
// Main Program
// Created 01/12/2001; 13:40:44

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "graphic_tetris.h" 



//Waiting Function for the Level Difficulty
void wait(unsigned short int w)
{
OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER,w);
	
	 while(!OSTimerExpired(USER_TIMER));
	
}

/*Find the Hardware Version for adjusting speed (found in TIGCC help)*/

unsigned long GetHardwareVersion ()
{
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000 &&
    *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1);
}

//Draw a Block (see the NOTE in "graphic.h")

void des(unsigned short *pt,unsigned short x,unsigned short y)
{
unsigned	char i,j;
	for(i=0;i<4;i++)
	for(j=0;j<4;j++)
	{
	if (pt[i*4+j]!=0)
	Sprite8(x+j*7,y+i*5,8,piece[pt[i*4+j]-1],LCD_MEM,SPRT_XOR);
	}
}


//Clock Definition...

INT_HANDLER oldint5 = NULL;

volatile int mseconds50 = 0; // = 50 milliseconds
volatile int seconds    = 0; // one second
volatile int dix    = 0;     // second/10=100 milliseconds
volatile int minutes    = 0;  // one minute
volatile int resettime  = 1;  // reset the clock
volatile int running  =0;     // if 1,the clock is running...

int mode;

//total playing time...
int total_hour;
int total_min;
int total_sec;



DEFINE_INT_HANDLER (myint5handler) {
    //----------------------------------------------
    // if resettime is not 0 all clock variables are
    // reset to 0
    //----------------------------------------------
  
    if (resettime) {
        mseconds50=seconds=minutes=resettime=0;
    }
    else if (running==1){
    
        mseconds50++;
        dix=mseconds50>>1; // mseconds50 = 2 * dix
        
        if (mseconds50 == 19) {   // 19 * mseconds50 = one second
            mseconds50 = 0;
            seconds++;
            if (seconds == 60) {
                seconds = 0;
                minutes++;
              }
        }
  
  
    }
    ExecuteHandler(oldint5);
}

/*Structure for saving highscores...*/
typedef struct
  {
    char name[10];
    unsigned long score;
  } HSC_ITEM;
  
/*Structure for saving best time...*/

typedef struct
  {
    char name[10];
unsigned short min;
  unsigned short sec;
  unsigned short dix;
  
  } BT_ITEM;

/*Function to input your name (thanks to Zeljko Juric with Cave Blaster...)*/

  void input_str(char *str,int pla)
{
  int i=0,key=0;
  DrawStr(10,10,"CONGRATULATIONS!",A_NORMAL);
  FontSetSys(F_6x8);
  DrawStr(10,30,"You Entered The TOP!",A_NORMAL);
  DrawStr(10,50,"Enter Your Name:",A_NORMAL);
  if (!pla){
  FontSetSys(F_4x6);
  DrawStr(10,80,"You are first!You can send your record at",A_NORMAL);
  DrawStr(15,90,"coz.hubert@infonie.fr!",A_NORMAL);
  }
  FontSetSys(F_6x8);
  while(key!=13)
    {
      str[i]='_'; str[i+1]=' '; str[i+2]=0;
      DrawStr(30,60,str,A_REPLACE);
      key=ngetchx();
      if(key>=' '&&key<='~'&&i<8) str[i++]=key;
      if(key==257&&i)
      {
      	//str[i]=' ';
      	i--;
      }
}
str[i]=0;
}


//Give your rank in the highscores:1,2 or 3
void best(HSC_ITEM bestscore[],unsigned long score)
{
  int i;
  for(i=2;(bestscore[i-1].score<score)&&i;i--)
    memcpy(&bestscore[i],&bestscore[i-1],sizeof(HSC_ITEM));
  bestscore[i].score=score;
  ClrScr();
  FontSetSys(F_8x10);
  input_str(bestscore[i].name,i);
 }


//Give your rank in the best Time:1,2 or 3
void best2(BT_ITEM bestscore[],unsigned short min,unsigned short sec,unsigned short dix)
{
  int i;
  for(i=2;(600*bestscore[i-1].min+10*bestscore[i-1].sec+bestscore[i-1].dix>
  600*min+10*sec+dix)&&i;i--)
    memcpy(&bestscore[i],&bestscore[i-1],sizeof(BT_ITEM));
  bestscore[i].min=min;
  bestscore[i].sec=sec;
  bestscore[i].dix=dix;
  ClrScr();
  FontSetSys(F_8x10);
  input_str(bestscore[i].name,i);
 }


//When you make a line,the upper blocks go down...
  void  redes(int y)
{
 int i;
 for (i=0;i<5;i++)
 {
 	DrawLine(10,y+i,86,y+i,A_REVERSE);
 }
SCR_RECT zone_clip = {{0, 0, 160, 100}}; 
SCR_RECT a_sauver1 = {{10,0, 86, y-1}};
char buffer2[BITMAP_HDR_SIZE + 100*80/8];
         BitmapGet(&a_sauver1, buffer2);
         BitmapPut(10, 0, buffer2,&zone_clip,A_XOR);
         BitmapPut(10, 5, buffer2,&zone_clip,A_XOR);
	}

 
  
// Check if you make a line  
void lignea(int y,int *ligne)
{
	
	int i,j,k;
	for (j=0;j<5;j++)
	{
			k=0;
			for (i=0;i<12;i++)
			{
					if (y+5*j>=95)
					return;
					if (GetPix(10+i*7,y+j*5))
					k=k+1;
			}
 			if (k==12)
 			{
 				*ligne=*ligne+1;
 					redes(y+j*5);
			   
				}
		
			}
		
	}



//Test if you can move
//  x ,y = block postion 
//  xx,yy = test direction
// tab = contains the piece
//  test (5,7,1,0),it tests if you can go right...
 
int test(int x,int y,int xx,int yy, unsigned short *tab)
{
int i,j;
for (i=0;i<4;i++)
{
	for (j=0;j<4;j++)
  if (tab[i+4*j]!=0)
   {
  	if (GetPix(x+i*7+7*xx,y+j*5+5*yy))
  	return 1;	
  } 
}
return 0;
} 


// Main Function
void _main(void)
{
/*Initial Highscores...*/
static HSC_ITEM bestscore[3]={{"David",10000},{"David",3000},
    {"David",0}};
static BT_ITEM besttime[3]={{"David",2,42,5},{"David",5,0,0},
    {"David",6,0,0}};
ClrScr();
unsigned i;
int niv=0,key=0;
mode=0;
	FontSetSys(F_8x10); 
 GrayOn();
SetPlane(LIGHT_PLANE);
/* Draw the 'Tetris' Title*/


 for (i=0;i<4;i++) 
 {
 	DrawLine(0,i,159,i,A_NORMAL);
 	DrawLine(0,99-i,159,99-i,A_NORMAL);
 	DrawLine(i,0,i,100,A_NORMAL);
 	DrawLine(159-i,0,159-i,100,A_NORMAL);
 	
 }
 for (i=0;i<3;i++)
 {
 DrawLine(4+i,4+i,4+i,46-i,A_NORMAL);
 DrawLine(155-i,4+i,155-i,46-i,A_NORMAL);
 }
 DrawLine(7,5,152,5,A_NORMAL);
 DrawLine(6,45,153,45,A_NORMAL);
 DrawLine(5,46,154,46,A_NORMAL);
 	FontSetSys(F_4x6); 
 	printf_xy(100,90,"Time:%03d:%02d",total_hour,total_min);
 	DrawStr(10,90,"V 1.02  2002 by David COZ",A_NORMAL);
 	
 for (i=0;i<3;i++)
{
printf_xy(10,50+6*i,"%d.",i+1); 	
 	DrawStr(18,50+6*i,bestscore[i].name,A_NORMAL);
printf_xy(50,50+6*i,"%ld",bestscore[i].score); 	
printf_xy(85,50+6*i,"%d.",i+1); 	
 	DrawStr(93,50+6*i,besttime[i].name,A_NORMAL);
printf_xy(128,50+6*i,"%02d:%02d.%0d",besttime[i].min,besttime[i].sec,besttime[i].dix); 	


}

  SetPlane(DARK_PLANE);



for (i=0;i<4;i++) 
 {
 	DrawLine(0,i,159,i,A_NORMAL);
 	DrawLine(0,99-i,159,99-i,A_NORMAL);
 	DrawLine(i,0,i,100,A_NORMAL);
 	DrawLine(159-i,0,159-i,100,A_NORMAL);	
 }
 DrawLine(9,7,150,7,A_NORMAL);
 DrawLine(9,43,150,43,A_NORMAL);
 DrawLine(9,7,9,43,A_NORMAL);
 DrawLine(150,7,150,43,A_NORMAL);
 DrawLine(6,45,153,45,A_NORMAL);
 DrawLine(5,46,154,46,A_NORMAL);
 	 FontSetSys(F_6x8);
 	DrawStr(15,75,"NORMAL",A_REVERSE);
 	DrawStr(75,75,"50 LINES",A_REPLACE);
FontSetSys(F_4x6);
	printf_xy(100,90,"Time:%03d:%02d",total_hour,total_min);
	//DrawStr(100,90,"Time:%03d:%02d",total_hour,total_min);
	
 	DrawStr(10,90,"V 1.02  2002 by David COZ",A_NORMAL);
 	for (i=0;i<3;i++)
{
printf_xy(10,50+6*i,"%d.",i+1); 	
 	DrawStr(18,50+6*i,bestscore[i].name,A_NORMAL);
printf_xy(50,50+6*i,"%ld",bestscore[i].score); 	
printf_xy(85,50+6*i,"%d.",i+1); 	
 	DrawStr(93,50+6*i,besttime[i].name,A_NORMAL);
printf_xy(128,50+6*i,"%02d:%02d.%0d",besttime[i].min,besttime[i].sec,besttime[i].dix); 	
}

while (key!=999)
{
FontSetSys(F_8x10);
if (mode>9)
printf_xy(40,76,"Level : %d",niv);
if (mode<9)
{
DrawStr(15,75,"NORMAL",mode==0 ? A_REVERSE :A_REPLACE  );
 DrawStr(75,75,"50 LINES",mode==1 ? A_REVERSE :A_REPLACE  );
 }	
 	key=ngetchx();
 	SetPlane(DARK_PLANE);
if (key==13&&mode>9)
key=999;

	if (key==13&&mode<9)
{
for (i=74;i<86;i++)
DrawLine(7,i,155,i,A_REVERSE);

	mode+=10;
}

	if (key==264)
		{
			GrayOff();
		return;
		}
	if (key==338&&mode==1)
	mode=0;
if (key==344&&mode==0)
	mode=1;
		
		if (key==344&&mode>9)
	{
		if (niv<9)
		niv++;
		else
		niv=0;
		}
		if (key==338&&mode>9)
	{
		if (niv>0)
		niv--;
		else
		niv=9;
		}
		
} 	
GrayOff();



 ClrScr();
 mode-=10;
	FontSetSys(F_6x8); 
DrawLine(87,0,87,99,A_NORMAL);
DrawLine(94,0,94,99,A_NORMAL);
DrawLine(94,0,159,0,A_NORMAL);
DrawLine(94,25,159,25,A_NORMAL);
DrawLine(94,41,159,41,A_NORMAL);
DrawLine(94,57,159,57,A_NORMAL);

DrawLine(94,99,160,99,A_NORMAL);
DrawLine(159,0,159,99,A_NORMAL);

for (i=95;i<100;i++)
{
DrawLine(3,i,94,i,A_NORMAL);
}
DrawLine(9,0,9,100,A_NORMAL);
for (i=0;i<4;i++)
{
DrawLine(i,0,i,100,A_NORMAL);
DrawLine(i+94,0,i+94,100,A_NORMAL);
}
for (i=0;i<95;i+=5)
{
	DrawLine(3,i,9,i,A_NORMAL);
DrawLine(87,i,94,i,A_NORMAL);

}
DrawStr(110,3,mode==1 ? "Time" :"Score",A_NORMAL);
DrawStr(99,30,"Lines 0",A_NORMAL);
DrawStr(110,62,"Next",A_NORMAL);



oldint5 = GetIntVec(AUTO_INT_5);
SetIntVec(AUTO_INT_5, myint5handler);
resettime = 1;   



INT_HANDLER save_int_1;
save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER); 


unsigned long int score=0,hw=GetHardwareVersion ();
int p,sp,mm,m,pp,k=(mode==2 ?0:hw==2 ?58:48),k1=(hw==2 ?58:48),x=59,old_x,y,ligne=0,l1;
// K and k1 ,'waiting' variables,depending on the calc hardware...  


// Speed,depending on the level...

sp=22-niv*2;
if (mode!=2)
{
	OSFreeTimer(USER_TIMER);
OSRegisterTimer(USER_TIMER,sp);
}

printf_xy(115,13,"%li",score);
	printf_xy(99,46,"Level %d",niv);


running=1;



randomize();

m=random(7);

a:
randomize();
// Choose a piece between the 7
mm=random(7);

p=0;
// Initial position of the piece
old_x=45;
x=45;
y=0;




unsigned short *pt=tableau[m*4+p];  //Contains the current piece matrix
                                    // (see "graphic.h")    
 
unsigned short *pt2=tableau[mm*4+p];//Contains the 'next'  piece matrix
                                    // (see "graphic.h")

//Draw the 'next' piece...
des(pt2,115,76);

c:

// check for Game Over
if ((test(x,y,0,1,pt)==1)||(mode==1&&ligne>49))
{
	
	//Game Over Block//
	
	
	running=0;
	if (mode)
	printf_xy(115, 13, "%02d:%02d.%0d",minutes,seconds,dix);

	if (test(x,y,0,1,pt)==1)



	OSFreeTimer(USER_TIMER);
	DrawStr(30,40,"GAME OVER",A_REPLACE);
	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec(AUTO_INT_5, oldint5);

	if ((score>bestscore[2].score)&&mode==0) best(bestscore,score);
	// you performed a highscore !
	
	if (((600*minutes+10*seconds+dix)<(600*besttime[2].min+10*besttime[2].sec+besttime[2].dix))&&mode==1&&ligne>49) 
	best2(besttime,minutes,seconds,dix);
		// you performed a time record !
		
     // Increase the total playing time...	
			total_sec+=seconds;
				if 	(total_sec>=60)
					{
						total_sec-=60;
						total_min++;
						}
					total_min+=minutes;
					if 	(total_min>=60)
					{
						total_min-=60;
						total_hour++;
					}

	while(ngetchx()!=13);
		return;
}


//Draw the 'current' piece on the top of the screen
des(pt,45,y);


while (key!=1)// while ESC not pressed (see after)  1=ESC
{
while(!(mode==2&&key==1)&&!(mode!=2&&OSTimerExpired(USER_TIMER)))
				// Do that until you pressed ESC or until it's time 
				// to move the piece down...
	{

if (mode==1)
printf_xy(115, 13, "%02d:%02d",minutes,seconds);
key=0;
// Keys Detection 
	for (i=1;i<k1*10;i++)
	{
		if (_rowread(0x7E)&0x02) //Left
		key=338;
	if (_rowread(0x7E)&0x08)//Right
	key=344;
	if (_rowread(0x3F)&0x01)//ESC
	key=1;
    if(_rowread(0x7E)&0x10)// 2nd
    key=2;
    if(_rowread(0x7E)&0x40)//Down
    key=3;
    if(_rowread(0x7D)&0x40)//Clear
    off();
    
     	if (_rowread(0x7E)&0x4)//Diamond
		break;
		if (key!=0)
		break;
	}
		
   //If ESC is pressed
      
      if (key==1)
      break;
	
		
	if (_rowread(0x7E)&0x4)//DOWN
    	{	
    	      score++;
    	        // Waiting Loop
    	    	for(i=0;i<k*600;i++);
		  	break;
    		}

	if (key!=0)
des(pt,old_x,y);
	 
	 		
if (key==3)//DIAMOND
{
	while(test(x,y,0,1,pt)==0)
	{
	score++;
	y+=5;
	}

}


			
	if (key==338 && test(x,y,-1,0,pt)==0)
	x=x-7; 
	
	if (key==344 && test(x,y,1,0,pt)==0)  
	x=x+7;
	
	if (key!=0)
	{
	     //Erase the block in previous position
	     des(pt,old_x,y);
         
         // Waiting Loop
	     for(i=0;i<k*1000;i++);
	  
				for(i=0;i<k*1000;i++);
				
 		    if (key==3)
		    break;
	}
	
		if (old_x!=x) 
		{
		  
			des(pt,old_x,y);
			des(pt,x,y);
			old_x=x;
			}
	  
  if(key==2)// 2nd
		{
		pp=p;
		pp=pp+1;
		des(pt,x,y);
		
		if (pp==4)
			pp=0;
		pt=tableau[m*4+pp];// pt contains the piece after rotation
      
					if (test(x,y,0,0,pt)==1)//if you can put the piece after rotation				
					{                       //this piece is the current piece
						pp=p;
						pt=tableau[m*4+p];
		     	}
		p=pp;	
	  des(pt,x,y);
	        // Waiting Loop
				  for (i=1;i<k*1000;i++);
   }


		 }
			// End of the 'While' loop:the piece move down...					 
				 
 
//delete the piece	 
     des(pt,x,y);
   
     	if (test(x,y,0,1,pt)==0)//if there is no block under...
      {	
     y=y+5;	
     }
      else
    {
       //The piece is blocked....  	
   
//Redraw the piece
des(pt,x,y);
	
	l1=ligne;
	//check if  you make a line..
	lignea(y,&ligne);
																					
	
	 printf_xy(99,30,"Lines %d",ligne);
	
	//Increase the score...
		if (ligne-l1==1)
	score+=40*(niv+1);
	if (ligne-l1==2)
	score+=100*(niv+1);
	if (ligne-l1==3)
	score+=300*(niv+1);
	if (ligne-l1==4)
	score+=1200*(niv+1);
	if (mode==0)
		 printf_xy(115,13,"%li",score);	
			
		//if you are in '50 lines' and lines>49
			if (ligne>49&&mode==1)
			goto c;
		
		
		if (ligne>=niv*10+10&&mode!=2)
			{
	//increase the speed
			niv++;
			sp-=2;
			if (niv>8)
       		sp++;
       		if (sp==0) sp=1;
     			printf_xy(99,46,"Level %d",niv);
			OSFreeTimer(USER_TIMER);
		 	OSRegisterTimer(USER_TIMER,sp);
			}
			//delete the 'next' piece..
			des(pt2,115,76);
	//the 'next' becomes the 'current'...	
m=mm;
	goto a;//return at the begiining...
	}
des(pt,x,y);

}

wait(1);
//Restore the timers
OSFreeTimer(USER_TIMER);
SetIntVec(AUTO_INT_5, oldint5);
SetIntVec (AUTO_INT_1, save_int_1);
	
//GKeyFlush();
//increase total playing time
total_sec+=seconds;
if 	(total_sec>=60)
{
	total_sec-=60;
	total_min++;
}
total_min+=minutes;
if 	(total_min>=60)
{
	total_min-=60;
	total_hour++;
}

}


// By David Coz     Coz.hubert@infonie.fr
